--[[
	Avobolt's (USGN#88318) ObjectPlayer
	Version: 1
]]

Player = {
	ID = 0,
}

-- get data

function Player:Health()
	return player(self.ID, "health")
end
function Player:MaxHealth()
	return player(self.ID, "maxhealth")
end
function Player:Armor()
	return player(self.ID, "armor")
end
function Player:Weapon()
	return player(self.ID, "weapontype")
end
function Player:Weapons()
	return playerweapons(self.ID)
end
function Player:X()
	return player(self.ID, "x")
end
function Player:Y()
	return player(self.ID, "y")
end
function Player:TileX()
	return player(self.ID, "tilex")
end
function Player:TileY()
	return player(self.ID, "tiley")
end
function Player:Rot()
	return player(self.ID, "rot")
end
function Player:IP()
	return player(self.ID, "ip")
end
function Player:Speed()
	return player(self.ID, "speedmod")
end
function Player:Team()
	return player(self.ID, "team")
end
function Player:Money()
	return player(self.ID, "money")
end
function Player:Score()
	return player(self.ID, "score")
end
function Player:Deaths()
	return player(self.ID, "deaths")
end
function Player:TeamKills()
	return player(self.ID, "teamkills")
end
function Player:Ping()
	return player(self.ID, "ping")
end
function Player:Idle()
	return player(self.ID, "idle")
end
function Player:USGN()
	return player(self.ID, "usgn")
end
function Player:IsEnemy(id)
	return (not (Player(id):Team() == self:Team()))
end
--set data, procedures

function Player:ChangeName(name, hide)
	hide = hide and 1 or 0
	parse('setname '..self.ID..' "'..name..'" '..hide)
end
function Player:SetArmor(armor)
	parse("setarmor "..self.ID.." "..armor)
end
function Player:SetHealth(hp)
	parse("sethealth "..self.ID.." "..hp)
end
function Player:SetMaxHealth(mhp)
	parse("setmaxhealth "..self.ID.." "..mhp)
end
function Player:ChangeTeam(team)
	if team == 1 then
		parse("maket "..self.ID)
	elseif team == 2 then
		parse("makect "..self.ID)
	else
		parse("makespec "..self.ID)
	end
end
function Player:Kick(reason)
	parse('kick '..self.ID..' "'..reason..'"')
end
function Player:Kill()
	parse("killplayer "..self.ID)
end
function Player:Damage(damage)
	local HP = player(self.ID, "health") - damage
	parse("sethealth "..self.ID.." "..HP)
end
function Player:Equip(weapon)
	parse("equip "..self.ID.." "..weapon)
end
function Player:Strip(weapon)
	parse("strip "..self.ID.." "..weapon)
end
function Player:ChangeSpeed(speed)
	parse("speedmod "..self.ID.." "..speed)
end
function Player:BanIP(duration, reason)
	parse('banip '..self.IP()..' '..duration..' "'..reason..'"')
end
function Player:BanUSGN(duration, reason)
	parse('banusgn '..self.USGN()..' '..duration..' "'..reason..'"')
end
function Player:Spawn(x, y)
	parse("spawnplayer "..self.ID.." "..x.." "..y)
end
function Player:Slap()
	parse("slap "..self.ID)
end
function Player:CustomKill(killer, weapon)
	parse('customkill '..killer..' "'..weapon..'" '..self.ID)
end
function Player:Msg(message)
	msg2(self.ID, message)
end
function Player:Reroute(ip)
	parse("reroute "..self.ID..' '..ip)
end
function Player:Shake(pow)
	parse("shake "..self.ID.." "..pow)
end
function Player:SetPos(x, y)
	parse("setpos "..self.ID.." "..x.." "..y)
end
function Player:CalculateDeath(damage)
	if ((self:Health() - damage) <= 0) then
		return true
	else
		return false
	end
end
function Player:SpawnProjectile(projectiletype, flydist, dir, x, y)
	if not y then
		local AnglePosition = function(rot, x, y, factor)
			if rot < -90 then rot = rot + 360 end
			local angle = math.rad(math.abs(rot + 90)) - math.pi
			local x = x + (math.cos(angle) * factor)
			local y = y + (math.sin(angle) * factor)
			return x, y
		end
		x, y = AnglePosition(self:Rot(),self:X(), self:Y(), 13)
	end
	dir = dir or self.Dir()
	parse("spawnprojectile "..self.ID.." "..projectiletype.." "..x.." "..y.." "..flydist.." "..dir)
end
function Player:FreeProjectile(id)
	parse("freeprojectile "..id.." "..self.ID)
end
function Player:RequestData(...)
	reqcld(self.ID, ...)
end
function Player:Sound(path)
	parse('sv_sound2 '..self.ID..' "'..path..'"')
end

setmetatable(Player, {
	__call = function(T, id)
		local Copy = function(t)
			local C = {}
			for k, v in pairs(t) do
				C[k] = v
			end
			return C
		end
		local t = Copy(T)
		if not id then 
			local tt = {}
			for i = 1, 32 do
				tt[i] = Player(i)
			end
			return tt
		end
		id = math.floor(id)
		if id < 1 then
			id = 1
		elseif id > 32 then
			id = 32
		end
		t.ID = id
		return t
	end
})