--[[
	Throwable knife script
	For CS2D
	By Avobolt (USGN#88318)
	Note: it needs my ObjectPlayer.lua to work!
]]
-- damage of the thrown knife
KnifeDamage = 75
-- strip knife from player when he throws it?
StripThrown = true

Distance = function(x1, y1, x2, y2)
    return math.floor(math.sqrt(math.pow(x1 - x2, 2) + math.pow(y1 - y2, 2)))
end

FreeLine = function(x1, y1, x2, y2)
    for i=1, Distance(x1, y1, x2, y2) do
        if tile(math.floor((x1 + i * math.cos(math.atan2(y2 - y1, x2 - x1))) / 32),math.floor((y1 + i * math.sin(math.atan2(y2 - y1, x2 - x1))) / 32), "walkable") == false then
            return false
        end
    end
    return true
end

DistanceSound = function(x, y, dist, sound)
	for k, v in pairs(player(0, "tableliving")) do
		local p = Player(v)
		if Distance(p:X(), p:Y(), x, y) <= dist and FreeLine(p:X(), p:Y(), x, y) then
			p:Sound(sound)
		end
	end
end

GetClosest = function(x, y)
	local record, ID = math.huge, 0
	for _, id in pairs(player(0, "tableliving")) do
		local dist = Distance(x,y, player(id, "x"), player(id, "y"))
		if dist < record then
			record = dist
			ID = id
		end
	end
	return ID, record
end

addhook("attack2", "OnAttack2")
OnAttack2 = function(id)
	local p = Player(id)
	if p:Weapon() == 50 then
		if StripThrown then
			p:Strip(50)
		end
		p:SpawnProjectile(50, 500, p:Rot(), 16)
	end
end
addhook("always", "OnMs100")
OnMs100 = function()
	local list=projectilelist(0, 0)
	for _, pro in pairs(list) do
		if projectile(pro.id, pro.player, "type") == 50 then
			local x, y = projectile(pro.id, pro.player, "x"), projectile(pro.id, pro.player, "y")
			local closest, dist = GetClosest(x, y)
			if closest > 0 and dist <= 12 then
				if Player(closest):IsEnemy(pro.player) or game("sv_friendlyfire") == "1" or (game("sv_friendlyfire") == "1" and closest == pro.player) then
					Player(pro.player):FreeProjectile(pro.id)
					local p = Player(closest)
					if p:CalculateDeath(KnifeDamage) then
						parse("spawnitem 50 "..p:TileX().." "..p:TileY())
						p:CustomKill(pro.player, "thrown knife")
					else
						p:Damage(KnifeDamage)
						DistanceSound(p:X(), p:Y(), 400, "/player/hit"..math.random(1,3)..".wav")
					end
				end
			end
		end
	end
end